package com.example.customlistviewtest;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	private ListView listview;
	private DataAdapter adapter;
	private LayoutInflater mInflater;
	private ArrayList<CData> alist;
	private Context context;
	private TextView title;
	private TextView text;
	private ImageView img;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		listview = (ListView) findViewById(R.id.list);
		
		alist = new ArrayList<CData>();
		adapter = new DataAdapter(this,alist);
		listview.setAdapter(adapter);
		context = this;
		
		adapter.add(new CData(this,"","", R.drawable.ic_launcher));
		adapter.add(new CData(this,"123","123", R.drawable.ic_launcher));
		adapter.add(new CData(this,"abc","abc", R.drawable.ic_launcher));
		
		listview.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
					long arg3) {	
				CData data = (CData)arg0.getAdapter().getItem(arg2);
				String title = data.getTitle();
				Toast.makeText(arg0.getContext(), title, Toast.LENGTH_SHORT).show();
			}
		});
	}
	
	private class DataAdapter extends ArrayAdapter<CData> {
		private LayoutInflater mInflater;
		
		public DataAdapter(Context context, ArrayList<CData> object) {
			super(context, 0, object);	
			
			mInflater = (LayoutInflater) context
						.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			
		}

		@Override
		public View getView(int position, View v, ViewGroup parent) {
			View view = null;
			if (v == null) {
				view = mInflater.inflate(R.layout.custom_view, null);
			} else {
				view = v;
			}
			final CData data = this.getItem(position);
			if (data != null) {
				title = (TextView) view.findViewById(R.id.tv1);
				text = (TextView) view.findViewById(R.id.tv2);
				img = (ImageView) view.findViewById(R.id.img);
				title.setText(data.getTitle());
				text.setText(data.getText());
				img.setImageResource(data.getImg());
			}
			return view;
		}
	}
	
	private class CData {
		private String Title;
		private String Text;
		private int Img;
	
		public CData(Context context, String mTitle, String mText, int mImg) {		
			Title = mTitle;
			Text = mText;
			Img = mImg;
		}	

		public String getTitle() {
			return Title;
		}

		public String getText() {
			return Text;
		}

		public int getImg() {
			return Img;
		}
	}
	
}
